using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");
    int max_c = opt<int>("c");
    int n = 1 + rnd.wnext(max_n, 2);
    int m = 1 + rnd.wnext(min(n, max_m), 2);

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = rnd.next(1, max_c);
    }

    vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        b[i] = rnd.next(1, max_c);
    }
    sort(b.begin(), b.end());

    printf("%d %d\n", n, m);
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", a[i]);
    }
    printf("\n");
    for (int i = 0; i < m; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", b[i]);
    }
    printf("\n");
}

