using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>
#include <unordered_map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

const int C = 100000;

void solver() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> cnt;
    unordered_map<int, int> utimes; //T -> number in cnt
    vector <pair<int, int>> times; //T -> time, used number
    fori(i, n) {
        cin >> a[i];
        if (utimes.find(a[i]) == utimes.end()) {
            int k = cnt.size();
            cnt.pb(0);
            utimes[a[i]] = k;
            int t = a[i];
            while (t < 2 * C) {
                times.emplace_back(t, k);
                t += a[i];
            }
        }
        int k = utimes[a[i]];
        ++cnt[k];
    }
    sort(all(times));

    vector<int> b(m);
    fori(i, m) { cin >> b[i]; }
    b.pb(INT_MAX);

    int free = 0;
    queue<int> wait;
    int tp = 0;
    int bp = 0;

    vector<int> ans(m);
    while (!wait.empty() || b[bp] < INT_MAX) {
        if (times[tp].X >= b[bp]) {
            if (free > 0) {
                ans[bp] = b[bp];
                --free;
            } else {
                wait.push(bp);
            }
            ++bp;
        } else {
            auto e = times[tp];
            if (wait.empty() || cnt[e.Y] == 0) {
                ++tp;
                continue;
            }
            free += cnt[e.Y];
            cnt[e.Y] = 0;
            while (times[tp + 1].X == e.X) {
                ++tp;
                free += cnt[times[tp].Y];
                cnt[times[tp].Y]= 0;
            }
            ++tp;
            while (!wait.empty() && free > 0) {
                ans[wait.front()] = e.X;
                wait.pop();
                --free;
            }
        }
    }

    fori(i, m) {
        cout << ans[i] << " ";
    }
    cout << "\n";

}

int main() {
//    fastio;
    solver();
}
